From 82b6b815f3d27d7b9da9abbd97cb05ccd13d048b Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Jun 30 2016 10:04:51 +0000
Subject: [PATCH 504/1001] Adjust the login and logout pages for OIDC


---

diff --git a/hubs/app.py b/hubs/app.py
index 98c86a1..74c751a 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -101,7 +101,7 @@ def shutdown_session(exception=None):
 @app.route('/')
 def index():
     if not authenticated():
-        return flask.redirect(flask.url_for('login_fedora'))
+        return flask.redirect(flask.url_for('login'))
 
     return flask.redirect(flask.url_for('hub', name=flask.g.auth.nickname))
 
@@ -468,56 +468,33 @@ FAS = OpenIDConnect(app, credentials_store=flask.session )
 def login():
     default = flask.url_for('index')
     next_url = flask.request.args.get('next', default)
-    if authenticated():
-        return flask.redirect(next_url)
-
-    openid_server = flask.request.form.get('openid', None)
-    if openid_server:
-        return oid.try_login(
-            openid_server, ask_for=['email', 'fullname', 'nickname'],
-            ask_for_optional=[])
-
-    return flask.render_template(
-        'login.html', next=oid.get_next_url(), error=oid.fetch_error())
+    if is_safe_url(next_url):
+        return_point = next_url
+    else:
+        return_point = default
 
+    hubs.models.User.get_or_create(
+        session, username=flask.g.auth.user, fullname=flask.g.auth.fullname)
 
-@app.route('/login/fedora/')
-@app.route('/login/fedora')
-@oid.loginhandler
-def login_fedora():
-    # default = flask.url_for('profile_redirect')
-    # next_url = flask.request.args.get('next', default)
-    return oid.try_login(
-        'https://id.fedoraproject.org',
-        ask_for=['email', 'fullname', 'nickname'],
-        ask_for_optional=[])
+    return flask.redirect(return_point)
 
 
 @app.route('/logout/')
 @app.route('/logout')
 def logout():
-    if 'openid' in flask.app.session:
-        flask.app.session.pop('openid')
-    return flask.redirect(flask.url_for('index'))
+    next_url = flask.url_for('index')
+    if 'next' in flask.request.values:  # pragma: no cover
+        if is_safe_url(flask.request.args['next']):
+            next_url = flask.request.values['next']
 
+    if next_url == flask.url_for('auth_login'):  # pragma: no cover
+        next_url = flask.url_for('index')
 
-@oid.after_login
-def after_openid_login(resp):
-    default = flask.url_for('index')
-    if not resp.identity_url:
-        return flask.redirect(default)
-
-    openid_url = resp.identity_url
-    flask.app.session['openid'] = openid_url
-    flask.app.session['fullname'] = resp.fullname
-    flask.app.session['nickname'] = resp.nickname or resp.fullname
-    flask.app.session['email'] = resp.email
-
-    openid = openid_url.strip('/').split('/')[-1]
-    hubs.models.User.get_or_create(
-        session, openid=openid, fullname=resp.fullname)
+    if authenticated():
+        FAS.logout()
+        flask.session.auth = None
+        flask.flash(gettext('You have been logged out'))
 
-    next_url = flask.request.args.get('next', default)
     return flask.redirect(next_url)
 
 
